#########################################################################
# Copyright (c) 2002, 2003 Grgoire Weber. All Rights Reserved.
# 
# This file is part of CMFCollection.
# 
# CMFCollection is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CMFCollection is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with CMFCollection; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#########################################################################
"""Mix in class managing configuration

$Id: $
"""
__version__ = "$Revision: $"


class Configuration:

    def _updateProperties(self, properties):
        for k,v in properties.items():
            self._updateProperty(k,v)

    def setConfiguration(self, config):
        """Configure
        """
        if config.has_key('_properties'):
            # set own properties
            self._updateProperties(config['_properties'])
        if config.has_key('_container'):
            # loop over all objects to instantiate
            for id, cfg in config['_container'].items():
                # instantiate object
                obj = self._addObject(id)
                # configure object
                obj.setConfiguration(cfg)
