#########################################################################
# Copyright (c) 2002, 2003 Grgoire Weber. All Rights Reserved.
# 
# This file is part of CMFCollection.
# 
# CMFCollection is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# CMFCollection is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with CMFCollection; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#########################################################################
""" XXX



$Id: $
"""
__version__ = "$Revision: $"

import sys

from Products.CMFCore import utils, CMFCorePermissions
from Products.CMFCore.DirectoryView import registerFileExtension, registerDirectory
from Products.CMFCore.FSDTMLMethod import FSDTMLMethod

import CollectionTool
import CollectionType


contentClasses = (CollectionType.CollectionType, )
contentConstructors = (CollectionType.addCollectionType, )
tools = (CollectionTool.CollectionTool, )
bases = (CollectionType.CollectionType, ) + tools

z_bases = utils.initializeBasesPhase1(bases, sys.modules[ __name__ ])

# This is used by a script (external method) that can be run
# to set up CMFCollection in an existing CMF Site instance.
collection_globals = globals()

# Make the skins available as DirectoryViews
registerDirectory('skins', globals())
registerDirectory('skins/collection', globals())

# register javascript files as dtml methods
registerFileExtension('js', FSDTMLMethod)

def initialize(context):
    utils.initializeBasesPhase2(z_bases, context)

#    context.registerHelp(directory='help')
#    context.registerHelpTitle('CMFCollection Help')

    # CMF Initializers
    utils.ContentInit(
        'CMFCollection Content Object'
        ,content_types = contentClasses
        ,permission = CMFCorePermissions.AddPortalContent
        ,extra_constructors = contentConstructors
        ,fti = CollectionType.factory_type_information
        ).initialize(context)

    utils.ToolInit(meta_type='CMF Collection Tool', tools=tools,
                   product_name='CMFCollection', icon='tool.gif',
                   ).initialize(context)

    utils.registerIcon(Slots.Slots, 'zmi/slots.gif', globals())
    utils.registerIcon(Slots.SlotDefinition, 'zmi/slot.gif', globals())
    utils.registerIcon(Helpers.Helpers, 'zmi/helpers.gif', globals())
    utils.registerIcon(Helpers.HelperTemplates, 'zmi/helper_templates.gif', globals())
    utils.registerIcon(Helpers.TemplateDefinition, 'zmi/template.gif', globals())
    utils.registerIcon(Types.Types, 'zmi/types.gif', globals())
    utils.registerIcon(Types.TypeDefinition, 'zmi/type.gif', globals())
    utils.registerIcon(Types.SlotConfiguration, 'zmi/slot.gif', globals())
    utils.registerIcon(Types.HelperConfiguration, 'zmi/helper_templates.gif', globals())
   
